diff --git a/src/core/ngx_palloc.c b/src/core/ngx_palloc.c
index 3e1c9f2..e28796d 100644
--- a/src/core/ngx_palloc.c
+++ b/src/core/ngx_palloc.c
@@ -293,6 +293,31 @@ ngx_pcalloc(ngx_pool_t *pool, size_t size)
     return p;
 }
 
+void *
+ngx_prealloc(ngx_pool_t *pool, void *ptr, size_t old_size, size_t new_size)
+{
+  void *new;
+  if ((u_char*) ptr + old_size == pool->d.last &&
+      pool->d.last + new_size <= pool->d.end) {
+
+    /*
+     * the str allocation is last in the pool
+     * and there is space for new len
+     */
+
+    pool->d.last += new_size;
+    return ptr;
+  }
+
+  new = ngx_palloc(pool, new_size);
+  if (new == NULL) {
+    return NULL;
+  }
+
+  ngx_memcpy((u_char*)new, (u_char*)ptr, old_size);
+
+  return new;
+}
 
 ngx_pool_cleanup_t *
 ngx_pool_cleanup_add(ngx_pool_t *p, size_t size)
diff --git a/src/core/ngx_palloc.h b/src/core/ngx_palloc.h
index f9d5216..4eb2af4 100644
--- a/src/core/ngx_palloc.h
+++ b/src/core/ngx_palloc.h
@@ -69,6 +69,7 @@ typedef struct {
 
 void *ngx_alloc(size_t size, ngx_log_t *log);
 void *ngx_calloc(size_t size, ngx_log_t *log);
+void *ngx_prealloc(ngx_pool_t *pool, void *ptr, size_t old_size, size_t new_zie);
 
 ngx_pool_t *ngx_create_pool(size_t size, ngx_log_t *log);
 void ngx_destroy_pool(ngx_pool_t *pool);
diff --git a/src/core/ngx_rbtreehash.c b/src/core/ngx_rbtreehash.c
new file mode 100644
index 0000000..90c6adc
--- /dev/null
+++ b/src/core/ngx_rbtreehash.c
@@ -0,0 +1,634 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+
+typedef struct {
+    u_char              color;
+    uint32_t            crc32;
+    size_t              len;
+    u_char              data[1];
+} ngx_rbtreehash_node_t;
+
+typedef struct {
+    ngx_str_t    key;
+    ngx_str_t    data;
+} ngx_rbtreehash_key_t;
+
+typedef struct {
+    ngx_pool_t         *pool;	/* this pool need only for tempory using and must destroy afer create tree */
+    ngx_array_t         keys;	/* keys for hash */
+    ngx_rbtreehash_t   *hash;
+} ngx_rbtreehash_ctx_t;
+
+static ngx_command_t  ngx_rbtreehash_commands[] = {
+    ngx_null_command
+};
+
+static ngx_core_module_t  ngx_rbtreehash_module_ctx = {
+    ngx_string("rbtreehash"),
+    NULL,
+    NULL
+};
+
+ngx_module_t  ngx_rbtreehash_module = {
+    NGX_MODULE_V1,
+    &ngx_rbtreehash_module_ctx,            /* module context */
+    ngx_rbtreehash_commands,               /* module directives */
+    NGX_CORE_MODULE,                       /* module type */
+    NULL,                                  /* init master */
+    NULL,                                  /* init module */
+    NULL,                                  /* init process */
+    NULL,                                  /* init thread */
+    NULL,                                  /* exit thread */
+    NULL,                                  /* exit process */
+    NULL,                                  /* exit master */
+    NGX_MODULE_V1_PADDING
+};
+
+static void*
+ngx_rbtreehash_alloc(ngx_rbtreehash_pool_t *pool, size_t size)
+{
+    if (pool->pool) {
+	/* use pool to allocated memory */
+	return ngx_palloc(pool->pool, size);
+    }
+
+    if (pool->shm_zone) {
+	/* or shm */
+	return ngx_slab_alloc((ngx_slab_pool_t *) pool->shm_zone->shm.addr,
+	    size);
+    }
+
+    /* or system system memory */
+    if (!pool->log) {
+	/* if not set log for pool use cycle log */
+	return ngx_alloc(size, ngx_cycle->log);
+    }
+
+    return ngx_alloc(size, pool->log);
+}
+
+static void
+ngx_rbtreehash_free(ngx_rbtreehash_pool_t *pool, void *p)
+{
+    if (pool->pool) {
+	/* can't have free in pool-based alloc */
+	return;
+    }
+
+    if (pool->shm_zone) {
+	ngx_slab_free((ngx_slab_pool_t *) pool->shm_zone->shm.addr, p);
+	return;
+    }
+
+    ngx_free(p);
+}
+
+static void
+ngx_rbtreehash_rbtree_insert_value(ngx_rbtree_node_t *temp,
+    ngx_rbtree_node_t *node, ngx_rbtree_node_t *sentinel)
+{
+    ngx_rbtree_node_t           **p;
+    ngx_rbtreehash_node_t        *rn, *rnt;
+
+    for ( ;; ) {
+
+	if (node->key < temp->key) {
+
+	    p = &temp->left;
+
+	} else if (node->key > temp->key) {
+
+	    p = &temp->right;
+
+	} else { /* node->key == temp->key */
+
+	    rn = (ngx_rbtreehash_node_t *) &node->color;
+	    rnt = (ngx_rbtreehash_node_t *) &temp->color;
+
+	    p = rn->crc32 < rnt->crc32
+		? &temp->left : &temp->right;
+	}
+
+	if (*p == sentinel) {
+	    break;
+	}
+
+	temp = *p;
+    }
+
+    *p = node;
+    node->parent = temp;
+    node->left = sentinel;
+    node->right = sentinel;
+    ngx_rbt_red(node);
+}
+
+ngx_rbtree_node_t* ngx_rbtreehash_insert(ngx_rbtreehash_t *hash, ngx_str_t *key,
+    void *value, size_t len)
+{
+    uint32_t                n;
+    ngx_rbtree_node_t      *node;
+    ngx_rbtreehash_node_t  *rn;
+
+    n = offsetof(ngx_rbtree_node_t, color)
+	+ offsetof(ngx_rbtreehash_node_t, data)
+	+ len;
+
+    node = ngx_rbtreehash_alloc(&hash->pool, n);
+    if (node == NULL) {
+	return NULL;
+    }
+    hash->data->nodes++;
+
+    rn = (ngx_rbtreehash_node_t*) &node->color;
+
+    node->key = ngx_lookup3_hashlittle(key->data, key->len, 0);
+    rn->crc32 = ngx_crc32_short(key->data, key->len);
+    rn->len = len;
+    ngx_memcpy(rn->data, value, len);
+
+    ngx_rbtree_insert(hash->data->tree, node);
+
+    return node;
+}
+
+ngx_int_t ngx_rbtreehash_delete(ngx_rbtreehash_t *hash, ngx_str_t *key)
+{
+    ngx_uint_t              hash32;
+    ngx_uint_t              crc32;
+    ngx_rbtree_node_t      *node;
+    ngx_rbtreehash_node_t  *rn;
+
+    hash32 = ngx_lookup3_hashlittle(key->data, key->len, 0);
+    crc32 = ngx_crc32_short(key->data, key->len);
+    node = hash->data->tree->root;
+
+    while (node != hash->data->tree->sentinel) {
+	if (hash32 < node->key) {
+	    node = node->left;
+	    continue;
+	}
+
+	if (hash32 > node->key) {
+	    node = node->right;
+	    continue;
+	}
+
+	do {
+	    rn = (ngx_rbtreehash_node_t*) &node->color;
+
+	    if (crc32 == rn->crc32) {
+		break;
+	    }
+
+	    if (crc32 == rn->crc32) {
+		break;
+	    }
+
+	    node = crc32 < rn->crc32 ? node->left : node->right;
+	} while (node != hash->data->tree->sentinel && hash32 == node->key);
+
+	break;
+    }
+
+    if (node == hash->data->tree->sentinel) {
+	return NGX_OK;
+    }
+
+    ngx_rbtree_delete(hash->data->tree, node);
+
+    ngx_rbtreehash_free(&hash->pool, node);
+
+    hash->data->nodes--;
+
+    return NGX_OK;
+}
+
+ngx_int_t ngx_rbtreehash_init(ngx_rbtreehash_t *hash)
+{
+    ngx_rbtree_node_t      *sentinel;
+
+    hash->data = ngx_rbtreehash_alloc(&hash->pool, sizeof(ngx_rbtreehash_hash_t));
+    ngx_memzero(hash->data, sizeof(ngx_rbtreehash_hash_t));
+
+    hash->data->tree = ngx_rbtreehash_alloc(&hash->pool, sizeof(ngx_rbtree_t));
+    if (hash->data->tree == NULL) {
+	return NGX_ERROR;
+    }
+
+    sentinel = ngx_rbtreehash_alloc(&hash->pool, sizeof(ngx_rbtree_node_t));
+    if (sentinel == NULL) {
+	return NGX_ERROR;
+    }
+
+    ngx_rbtree_init(hash->data->tree, sentinel,
+	ngx_rbtreehash_rbtree_insert_value);
+
+    return NGX_OK;
+}
+
+ngx_int_t ngx_rbtreehash_destroy(ngx_rbtreehash_t *hash)
+{
+    ngx_rbtree_node_t      *node;
+
+    for (;;) {
+	if (hash->data->tree->root == hash->data->tree->sentinel) {
+	    break;
+	}
+
+	node = ngx_rbtree_min(hash->data->tree->root,
+	    hash->data->tree->sentinel);
+
+	ngx_rbtree_delete(hash->data->tree, node);
+
+	ngx_rbtreehash_free(&hash->pool, node);
+
+    }
+
+    return NGX_OK;
+}
+
+static ngx_int_t
+ngx_rbtreehash_init_tree(ngx_shm_zone_t *shm_zone, void *data)
+{
+    uint32_t                i;
+    ngx_rbtreehash_t       *hash;
+    ngx_rbtreehash_ctx_t   *octx = data;
+    ngx_rbtreehash_ctx_t   *ctx;
+    ngx_rbtreehash_key_t   *keys;
+
+    ctx = shm_zone->data;
+
+    if (octx &&
+	ngx_strncmp(ctx->hash->pool.shm_key.data,
+	    octx->hash->pool.shm_key.data,
+	    ctx->hash->pool.shm_key.len) != 0) {
+	ngx_log_error(NGX_LOG_EMERG, shm_zone->shm.log, 0,
+	    "rbhash use path \"%s\" with previously it used "
+	    "the \"%s\"", ctx->hash->pool.shm_key.data,
+	    octx->hash->pool.shm_key.data);
+	return NGX_ERROR;
+    }
+
+    if (ngx_rbtreehash_init(ctx->hash) != NGX_OK) {
+	return NGX_ERROR;
+    }
+
+    keys = ctx->keys.elts;
+
+    for (i = 0; i < ctx->keys.nelts; i++) {
+	if (keys[i].key.len == 0) {
+	    continue;
+	}
+
+	if (ngx_rbtreehash_insert(ctx->hash, &keys[i].key,
+		keys[i].data.data,
+		keys[i].data.len) == NULL) {
+	    return NGX_ERROR;
+	}
+
+    }
+
+    if (ctx->pool) {
+	ngx_destroy_pool(ctx->pool);
+	ctx->pool = NULL;
+    }
+
+    /* setup hash->data to all linked conf */
+    for (hash = ctx->hash; hash->next; hash = hash->next) {
+	hash->next->data = hash->data;
+    }
+
+    for (; hash->prev; hash = hash->prev) {
+	hash->prev->data = hash->data;
+    }
+
+    return NGX_OK;
+}
+
+void* ngx_rbtreehash_find(ngx_rbtreehash_t *hash, ngx_str_t *key, size_t *len)
+{
+    ngx_uint_t              hash32;
+    ngx_uint_t              crc32;
+    ngx_rbtree_node_t      *node;
+    ngx_rbtree_node_t      *sentinel;
+    ngx_rbtreehash_node_t  *rn;
+
+    if (!hash->data) {
+	return NULL;
+    }
+
+    if (hash->data->nodes == 0) {
+	return NULL;
+    }
+
+    if (key->len == 0) {
+	return NULL;
+    }
+
+    hash32 = ngx_lookup3_hashlittle(key->data, key->len, 0);
+    crc32 = ngx_crc32_short(key->data, key->len);
+
+    node = hash->data->tree->root;
+    sentinel = hash->data->tree->sentinel;
+
+    while (node != sentinel) {
+	if (hash32 < node->key) {
+	    node = node->left;
+	    continue;
+	}
+
+	if (hash32 > node->key) {
+	    node = node->right;
+	    continue;
+	}
+
+	do {
+	    rn = (ngx_rbtreehash_node_t*) &node->color;
+
+	    if (crc32 == rn->crc32) {
+		*len = rn->len;
+		return rn->data;
+	    }
+
+	    if (crc32 == rn->crc32) {
+		break;
+	    }
+
+	    node = crc32 < rn->crc32 ? node->left : node->right;
+
+	} while (node != sentinel && hash32 == node->key);
+	break;
+    }
+
+    return NULL;
+}
+
+char *
+ngx_rbtreehash_crete_shared_by_size(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    ngx_str_t                  *value;
+    char                       *p = conf;
+    size_t                      size;
+    ngx_rbtreehash_t           *hash;
+
+    hash = (ngx_rbtreehash_t*) (p + cmd->offset);
+
+    if (cf->args->nelts != 2) {
+	return "need two args";
+    }
+
+    value = cf->args->elts;
+
+    if (hash->pool.shm_zone) {
+	return "is duplicate";
+    }
+
+    size = ngx_parse_offset(&value[1]);
+
+    hash->pool.shm_key.len = value[0].len + NGX_INT_T_LEN + sizeof(" ") - 1 + NGX_INT_T_LEN;
+    hash->pool.shm_key.data = ngx_palloc(cf->pool, hash->pool.shm_key.len);
+    if (hash->pool.shm_key.data == NULL) {
+	return NGX_CONF_ERROR;
+    }
+
+    ngx_sprintf(hash->pool.shm_key.data, "%V%d %d", &value[0], size, rand());
+
+    if (size < (size_t) (8 * ngx_pagesize)) {
+	size = (size_t) (8 * ngx_pagesize);
+    } else {
+	size = 8 * ngx_pagesize * (size / (8 * ngx_pagesize) + 1);
+    }
+
+    hash->pool.shm_zone = ngx_shared_memory_add(cf, &hash->pool.shm_key,
+	size,
+	&ngx_rbtreehash_module);
+
+    if (hash->pool.shm_zone == NULL) {
+	return NGX_CONF_ERROR;
+    }
+
+    hash->pool.shm_zone->init = ngx_rbtreehash_init_tree;
+    hash->pool.shm_zone->data = hash;
+    hash->pool.pool = NULL;
+    hash->pool.log = cf->log;
+
+    return NGX_CONF_OK;
+}
+
+char *
+ngx_rbtreehash_from_path(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    ngx_str_t                  *value;
+    char                       *p = conf;
+    ngx_str_t                   data;
+    ngx_str_t                   path;
+    ngx_int_t                   fd;
+    ngx_file_info_t             fi;
+    ngx_rbtreehash_key_t       *key;
+    size_t                      need_shmem = 0;
+    ngx_rbtreehash_ctx_t       *ctx;
+    u_char                     *ptr;
+    u_char                     *ptr_last;
+    u_char                     *ptr_end;
+    size_t                      len;
+
+    ctx = ngx_pcalloc(cf->pool, sizeof(ngx_rbtreehash_ctx_t));
+    if (ctx == NULL) {
+	return NGX_CONF_ERROR;
+    }
+
+    ctx->hash = (ngx_rbtreehash_t*) (p + cmd->offset);
+
+    if (cf->args->nelts != 2) {
+	return "need two args";
+    }
+
+    value = cf->args->elts;
+
+    if (ctx->hash->pool.shm_zone) {
+	return "is duplicate";
+    }
+
+    ctx->pool = ngx_create_pool(4096, cf->log);
+    if (ctx->pool == NULL) {
+	return NGX_CONF_ERROR;
+    }
+
+    if (ngx_conf_full_name(cf->cycle, &value[1], 0) == NGX_ERROR) {
+	return NGX_CONF_ERROR;
+    }
+
+    path = value[1];	     /* shm_key is a path to file with data */
+
+    fd = ngx_open_file(path.data, NGX_FILE_RDONLY, NGX_FILE_OPEN, 0);
+    if (fd == NGX_INVALID_FILE) {
+	if (ngx_errno == NGX_ENOENT) {
+	    return NGX_CONF_OK;
+	}
+
+	ngx_log_error(NGX_LOG_CRIT, cf->log, ngx_errno,
+	    ngx_open_file_n " \"%s\" failed", path.data);
+	return NGX_CONF_ERROR;
+    }
+
+    if (ngx_fd_info(fd, &fi) == NGX_FILE_ERROR) {
+	ngx_log_error(NGX_LOG_CRIT, cf->log, ngx_errno,
+	    ngx_fd_info_n " \"%s\" failed", path.data);
+
+	return NGX_CONF_ERROR;
+    }
+
+    data.len = ngx_file_size(&fi);
+    data.data = mmap(NULL, data.len, PROT_READ, MAP_PRIVATE, fd, 0);
+    if (data.data == MAP_FAILED) {
+	return NGX_CONF_ERROR;
+    }
+
+    for (ptr = data.data, ptr_end = data.data + data.len, len = 0;
+	 ptr <= ptr_end; ptr++) {
+	if (*ptr == '\n' || ptr == ptr_end) {
+	    len++;
+	}
+    }
+
+    if (ngx_array_init(&ctx->keys, ctx->pool, len,
+	    sizeof(ngx_rbtreehash_key_t)) != NGX_OK) {
+	return NGX_CONF_ERROR;
+    }
+
+    key = ngx_array_push(&ctx->keys);
+    ngx_memzero(key, ctx->keys.size);
+    for (ptr_last = ptr = data.data, ptr_end = data.data + data.len
+	     ; ptr < ptr_end; ptr++) {
+	switch (*ptr) {
+	case ' ':
+	    {
+		if (*ptr == *ptr_last) {
+		    ptr++;
+		    ptr_last = ptr;
+		}
+		break;
+	    }
+	case ':':
+	    {
+		if (key->key.data != NULL) {
+		    continue;
+		}
+		key->key.len = ptr - ptr_last;
+		key->key.data = ngx_palloc(ctx->pool, key->key.len);
+		if (key->key.data == NULL) {
+		    goto error;
+		}
+
+		memcpy(key->key.data, ptr_last, key->key.len);
+
+		ptr++;
+		ptr_last = ptr;
+		break;
+	    }
+	case '\n':
+	    {
+		if (key->key.data == NULL) {
+		    key->key.len = ptr - ptr_last;
+		    key->key.data = ngx_palloc(ctx->pool, key->key.len);
+		    if (key->key.data == NULL) {
+			goto error;
+		    }
+
+		    memcpy(key->key.data, ptr_last, key->key.len);
+
+		    key->data = key->key;
+		} else {
+		    key->data.len = ptr - ptr_last;
+		    key->data.data = ngx_palloc(ctx->pool, key->data.len);
+		    if (key->data.data == NULL) {
+			goto error;
+		    }
+
+		    memcpy(key->data.data, ptr_last, key->data.len);
+		}
+
+		need_shmem += ngx_align(offsetof(ngx_rbtree_node_t, color)
+		    + offsetof(ngx_rbtreehash_node_t, data)
+		    + key->data.len,
+		    ngx_pagesize);
+
+		ptr++;
+		ptr_last = ptr;
+		key = ngx_array_push(&ctx->keys);
+		ngx_memzero(key, ctx->keys.size);
+		break;
+	    }
+	}
+    }
+
+    ctx->hash->pool.shm_key.len = path.len + NGX_INT_T_LEN;
+    ctx->hash->pool.shm_key.data = ngx_palloc(cf->pool, ctx->hash->pool.shm_key.len);
+    if (ctx->hash->pool.shm_key.data == NULL) {
+	goto error;
+    }
+
+    /* shm_key is path to file and value hash function on the contents of file Ð¾Ð¿*/
+    ngx_sprintf(ctx->hash->pool.shm_key.data, "%s %d", &path,
+	ngx_lookup3_hashlittle(data.data, data.len, 0));
+
+
+    munmap(data.data, data.len);
+
+    need_shmem += ngx_align(sizeof(ngx_rbtree_t), ngx_pagesize)
+	+ ngx_align(sizeof(ngx_rbtree_node_t), ngx_pagesize) /* sentinel */
+	+ ngx_align(sizeof(ngx_rbtreehash_hash_t), ngx_pagesize); /* hash_data */
+
+    if (need_shmem < (size_t) (8 * ngx_pagesize)) {
+	need_shmem = (size_t) (8 * ngx_pagesize);
+    } else {
+	need_shmem = 8 * ngx_pagesize * (need_shmem / (8 * ngx_pagesize) + 1);
+    }
+
+    ctx->hash->pool.shm_zone = ngx_shared_memory_add(cf, &ctx->hash->pool.shm_key,
+	need_shmem,
+	&ngx_rbtreehash_module);
+
+    if (ctx->hash->pool.shm_zone == NULL) {
+	goto error_wo_data;
+    }
+
+    ctx->hash->pool.shm_zone->init = ngx_rbtreehash_init_tree;
+    ctx->hash->pool.shm_zone->data = ctx;
+    ctx->hash->pool.pool = NULL;
+
+    return NGX_CONF_OK;
+
+ error:
+    munmap(data.data, data.len);
+ error_wo_data:
+    ngx_destroy_pool(ctx->pool);
+    return NGX_CONF_ERROR;
+}
+
+ngx_int_t ngx_rbtreehash_merge_value(ngx_rbtreehash_t *conf, ngx_rbtreehash_t *prev)
+{
+    ngx_rbtreehash_t *hash;
+
+    if (prev->pool.shm_zone || prev->pool.pool) {
+	conf->pool = prev->pool;
+    }
+
+    for (hash = prev; hash->next; hash = hash->next);
+    hash->next = conf;
+    conf->prev = hash;
+
+    return NGX_OK;
+}
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* c-file-offsets: ((arglist-cont-nonempty . 4)) */
+/* End: */
diff --git a/src/core/ngx_rbtreehash.h b/src/core/ngx_rbtreehash.h
new file mode 100644
index 0000000..45a06ba
--- /dev/null
+++ b/src/core/ngx_rbtreehash.h
@@ -0,0 +1,59 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+#ifndef __NGX_RBTREEHASH
+#define __NGX_RBTREEHASH
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+
+typedef struct {
+    /* in hash using shm_zone */
+    ngx_shm_zone_t     *shm_zone;
+    ngx_str_t           shm_key;
+
+    /* ... or pool */
+    ngx_pool_t         *pool;
+
+    ngx_log_t          *log;
+} ngx_rbtreehash_pool_t;
+
+typedef struct {
+    ngx_rbtree_t       *tree;
+    size_t              nodes;
+} ngx_rbtreehash_hash_t;
+
+typedef struct ngx_rbtreehash_s ngx_rbtreehash_t;
+
+struct ngx_rbtreehash_s {
+    ngx_rbtreehash_pool_t  pool;
+    ngx_rbtreehash_hash_t *data;
+
+    /* hack to pointer to next/prev config */
+    ngx_rbtreehash_t      *next;
+    ngx_rbtreehash_t      *prev;
+};
+
+ngx_int_t ngx_rbtreehash_init(ngx_rbtreehash_t *hash);
+ngx_int_t ngx_rbtreehash_destroy(ngx_rbtreehash_t *hash);
+ngx_rbtree_node_t* ngx_rbtreehash_insert(ngx_rbtreehash_t *hash, ngx_str_t *key,
+					 void *value, size_t len);
+ngx_int_t ngx_rbtreehash_delete(ngx_rbtreehash_t *hash, ngx_str_t *key);
+void *ngx_rbtreehash_find(ngx_rbtreehash_t *hash, ngx_str_t *key, size_t *len);
+
+char *ngx_rbtreehash_crete_shared_by_size(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
+char *ngx_rbtreehash_from_path(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
+
+ngx_int_t ngx_rbtreehash_merge_value(ngx_rbtreehash_t *conf, ngx_rbtreehash_t *prev);
+
+extern ngx_module_t  ngx_rbtreehash_module;
+
+#endif //__NGX_RBTREEHASH
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* c-file-offsets: ((arglist-cont-nonempty . 4)) */
+/* End: */
diff --git a/src/core/ngx_times.c b/src/core/ngx_times.c
index 3105beb..4f5d857 100644
--- a/src/core/ngx_times.c
+++ b/src/core/ngx_times.c
@@ -60,7 +60,7 @@ ngx_time_update(time_t sec, ngx_uint_t msec)
     u_char          *p0, *p1, *p2;
     ngx_tm_t         tm, gmt;
     ngx_time_t      *tp;
-    struct timeval   tv;
+    ngx_timeval_t    tv;
 
     if (!ngx_trylock(&ngx_time_lock)) {
         return;
diff --git a/src/event/modules/ngx_select_module.c b/src/event/modules/ngx_select_module.c
index a09712b..8f27de9 100644
--- a/src/event/modules/ngx_select_module.c
+++ b/src/event/modules/ngx_select_module.c
@@ -214,7 +214,7 @@ ngx_select_process_events(ngx_cycle_t *cycle, ngx_msec_t timer,
     ngx_err_t          err;
     ngx_uint_t         i, found;
     ngx_event_t       *ev, **queue;
-    struct timeval     tv, *tp;
+    ngx_timeval_t      tv, *tp;
     ngx_connection_t  *c;
 
     if (max_fd == -1) {
diff --git a/src/event/ngx_event.c b/src/event/ngx_event.c
index e30c563..dadd1c0 100644
--- a/src/event/ngx_event.c
+++ b/src/event/ngx_event.c
@@ -71,6 +71,12 @@ ngx_atomic_t   ngx_stat_reading0;
 ngx_atomic_t  *ngx_stat_reading = &ngx_stat_reading0;
 ngx_atomic_t   ngx_stat_writing0;
 ngx_atomic_t  *ngx_stat_writing = &ngx_stat_writing0;
+ngx_atomic_t   ngx_stat_requests_per_seconds0;
+ngx_atomic_t  *ngx_stat_requests_per_seconds = &ngx_stat_requests_per_seconds0;
+ngx_atomic_t   ngx_stat_requests_last_seconds0;
+ngx_atomic_t  *ngx_stat_requests_last_seconds = &ngx_stat_requests_last_seconds0;
+ngx_atomic_t   ngx_stat_requests_last0;
+ngx_atomic_t  *ngx_stat_requests_last = &ngx_stat_requests_last0;
 
 #endif
 
@@ -501,7 +507,10 @@ ngx_event_module_init(ngx_cycle_t *cycle)
            + cl          /* ngx_stat_requests */
            + cl          /* ngx_stat_active */
            + cl          /* ngx_stat_reading */
-           + cl;         /* ngx_stat_writing */
+           + cl          /* ngx_stat_writing */
+           + cl          /* ngx_stat_requests_per_seconds */
+           + cl          /* ngx_stat_requests_last_seconds */
+           + cl;         /* ngx_stat_requests_last */
 
 #endif
 
@@ -534,7 +543,9 @@ ngx_event_module_init(ngx_cycle_t *cycle)
     ngx_stat_active = (ngx_atomic_t *) (shared + 5 * cl);
     ngx_stat_reading = (ngx_atomic_t *) (shared + 6 * cl);
     ngx_stat_writing = (ngx_atomic_t *) (shared + 7 * cl);
-
+    ngx_stat_requests_per_seconds = (ngx_atomic_t *) (shared + 8 * cl);
+    ngx_stat_requests_last_seconds = (ngx_atomic_t *) (shared + 9 * cl);
+    ngx_stat_requests_last = (ngx_atomic_t *) (shared + 10 * cl);
 #endif
 
     (void) ngx_atomic_cmp_set(ngx_connection_counter, 0, 1);
diff --git a/src/event/ngx_event.h b/src/event/ngx_event.h
index 33c8cdc..55259e3 100644
--- a/src/event/ngx_event.h
+++ b/src/event/ngx_event.h
@@ -485,6 +485,10 @@ extern ngx_atomic_t  *ngx_stat_requests;
 extern ngx_atomic_t  *ngx_stat_active;
 extern ngx_atomic_t  *ngx_stat_reading;
 extern ngx_atomic_t  *ngx_stat_writing;
+extern ngx_atomic_t  *ngx_stat_requests_per_seconds;
+extern ngx_atomic_t  *ngx_stat_requests_last_seconds;
+extern ngx_atomic_t  *ngx_stat_requests_last;
+
 
 #endif
 
diff --git a/src/http/modules/ngx_http_auth_basic_module.c b/src/http/modules/ngx_http_auth_basic_module.c
index 1d2d75e..59c96db 100644
--- a/src/http/modules/ngx_http_auth_basic_module.c
+++ b/src/http/modules/ngx_http_auth_basic_module.c
@@ -18,7 +18,10 @@ typedef struct {
 
 
 typedef struct {
-    ngx_str_t                 realm;
+    ngx_str_t     realm;
+    ngx_hash_t    valid_user;
+    ngx_uint_t    valid_user_max_size;
+    ngx_uint_t    valid_user_bucket_size;
     ngx_http_complex_value_t  user_file;
 } ngx_http_auth_basic_loc_conf_t;
 
@@ -36,6 +39,8 @@ static ngx_int_t ngx_http_auth_basic_init(ngx_conf_t *cf);
 static char *ngx_http_auth_basic(ngx_conf_t *cf, void *post, void *data);
 static char *ngx_http_auth_basic_user_file(ngx_conf_t *cf, ngx_command_t *cmd,
     void *conf);
+static char *ngx_http_auth_basic_valid_user(ngx_conf_t *cf,
+    ngx_command_t *cmd, void *conf);
 
 
 static ngx_conf_post_handler_pt  ngx_http_auth_basic_p = ngx_http_auth_basic;
@@ -58,6 +63,28 @@ static ngx_command_t  ngx_http_auth_basic_commands[] = {
       offsetof(ngx_http_auth_basic_loc_conf_t, user_file),
       NULL },
 
+    { ngx_string("auth_basic_valid_user"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_HTTP_LMT_CONF
+                        |NGX_CONF_1MORE,
+      ngx_http_auth_basic_valid_user,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_auth_basic_loc_conf_t, valid_user),
+      NULL },
+
+    { ngx_string("auth_basic_valid_user_max_size"),
+      NGX_HTTP_MAIN_CONF|NGX_CONF_TAKE1,
+      ngx_conf_set_num_slot,
+      NGX_HTTP_MAIN_CONF_OFFSET,
+      offsetof(ngx_http_auth_basic_loc_conf_t, valid_user_max_size),
+      NULL },
+
+    { ngx_string("auth_basic_valid_user_bucket_size"),
+      NGX_HTTP_MAIN_CONF|NGX_CONF_TAKE1,
+      ngx_conf_set_num_slot,
+      NGX_HTTP_MAIN_CONF_OFFSET,
+      offsetof(ngx_http_auth_basic_loc_conf_t, valid_user_bucket_size),
+      NULL },
+
       ngx_null_command
 };
 
@@ -284,8 +311,19 @@ static ngx_int_t
 ngx_http_auth_basic_crypt_handler(ngx_http_request_t *r,
     ngx_http_auth_basic_ctx_t *ctx, ngx_str_t *passwd, ngx_str_t *realm)
 {
-    ngx_int_t   rc;
-    u_char     *encrypted;
+    u_char                          *encrypted;
+    ngx_int_t                        rc;
+    ngx_uint_t                       key;
+    ngx_http_auth_basic_loc_conf_t  *alcf;
+
+    alcf = ngx_http_get_module_loc_conf(r, ngx_http_auth_basic_module);
+    if (alcf->valid_user.size) {
+	key = ngx_hash_key_lc(r->headers_in.user.data, r->headers_in.user.len);
+	if (ngx_hash_find(&alcf->valid_user, key, r->headers_in.user.data,
+			  r->headers_in.user.len) == NULL) {
+	    return NGX_HTTP_UNAUTHORIZED;
+	}
+    }
 
     rc = ngx_crypt(r->pool, r->headers_in.passwd.data, passwd->data,
                    &encrypted);
@@ -375,6 +413,9 @@ ngx_http_auth_basic_create_loc_conf(ngx_conf_t *cf)
         return NGX_CONF_ERROR;
     }
 
+    conf->valid_user_max_size = NGX_CONF_UNSET_UINT;
+    conf->valid_user_bucket_size = NGX_CONF_UNSET_UINT;
+
     return conf;
 }
 
@@ -393,6 +434,10 @@ ngx_http_auth_basic_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child)
         conf->user_file = prev->user_file;
     }
 
+    if (conf->valid_user.buckets == NULL) {
+        conf->valid_user = prev->valid_user;
+    }
+
     return NGX_CONF_OK;
 }
 
@@ -477,3 +522,59 @@ ngx_http_auth_basic_user_file(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 
     return NGX_CONF_OK;
 }
+
+static char *
+ngx_http_auth_basic_valid_user(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    char                           *p = conf;
+    ngx_str_t                      *value;
+    ngx_uint_t                      i;
+    ngx_hash_t                     *valid_user;
+    ngx_hash_init_t                 hash;
+    ngx_array_t                     keys;
+    ngx_hash_key_t                 *key;
+    ngx_http_auth_basic_loc_conf_t *ablc = conf;
+
+    valid_user = (ngx_hash_t*) (p + cmd->offset);
+
+    if (valid_user->size) {
+	return "is duplicate";
+    }
+
+    if (ablc->valid_user_max_size == NGX_CONF_UNSET_UINT) {
+	ablc->valid_user_max_size = 512;
+    }
+
+    if (ablc->valid_user_bucket_size == NGX_CONF_UNSET_UINT) {
+	ablc->valid_user_bucket_size = 64;
+    }
+
+    hash.hash = valid_user;
+    hash.key = ngx_hash_key_lc;
+    hash.max_size = ablc->valid_user_max_size;
+    hash.bucket_size = ablc->valid_user_bucket_size;
+    hash.name = "auth_basic_valid_user";
+    hash.pool = cf->pool;
+    hash.temp_pool = cf->pool;
+
+    if (ngx_array_init(&keys, cf->pool,
+		       cf->args->nelts - 1, sizeof(ngx_hash_key_t))
+	== NGX_ERROR) {
+	return NGX_CONF_ERROR;
+    }
+
+    value = cf->args->elts;
+
+    for (i = 1; i < cf->args->nelts; i++) {
+	key = ngx_array_push(&keys);
+	key->key = value[i];
+	key->key_hash = ngx_hash_key_lc(key->key.data, key->key.len);
+	key->value = &value[i];
+    }
+
+    if (ngx_hash_init(&hash, keys.elts, keys.nelts) != NGX_OK) {
+	return NGX_CONF_ERROR;
+    }
+
+    return NGX_CONF_OK;
+}
